<?php

namespace Sharplogicians\Keycloak\Observer;

use Magento\Framework\Event\ObserverInterface;
use Magento\Framework\Event\Observer;
use Magento\Customer\Model\CustomerFactory;
use Magento\Customer\Api\CustomerRepositoryInterface;
use Magento\Customer\Model\Session as CustomerSession;
use Magento\Framework\App\Response\RedirectInterface;
use Sharplogicians\Keycloak\Model\Keycloak;

class KeycloakLogin implements ObserverInterface
{
    private $clientId = 'magento-client';

    private $clientSecret = 'YOUR_CLIENT_SECRET';

    private $keycloakBaseUrl = 'https://your-keycloak-domain/realms/magento-realm/protocol/openid-connect';

    private $customerFactory;

    private $customerRepository;

    private $customerSession;

    private $redirect;

    public function __construct(
        CustomerFactory $customerFactory,
        CustomerRepositoryInterface $customerRepository,
        CustomerSession $customerSession,
        RedirectInterface $redirect,
        Keycloak $keycloak
    ) {
        $this->customerFactory = $customerFactory;
        $this->customerRepository = $customerRepository;
        $this->customerSession = $customerSession;
        $this->redirect = $redirect;
        $this->keycloak = $keycloak;
    }

    public function execute(Observer $observer)
    {
        //echo $accessToken = $_SESSION['keycloak_access_token'];

        if ($this->customerSession->isLoggedIn()) {
            return;
        }

        try {
            $accessToken = $this->keycloak->getAccessToken();
            $userInfo = $this->keycloak->getUserInfo($accessToken);
            //echo '<pre>';
            //print_r($userData);

            if (!isset($userData['email'])) {
                return;
            }

            $customer = $this->keycloak->getOrCreateCustomer($userInfo['email'], $userInfo['name']);
            $this->customerSession->setCustomerAsLoggedIn($customer);
            $observer->getControllerAction()->getResponse()->setRedirect('/customer/account');
        } catch (\Exception $e) {
            
        }
    }
}
